'use strict';

app.controller('RemoteCtrl', ['$scope', '$rootScope', 'FormService', 'RestService', 'remoteDeliveryQualities', 'formData',
    function ($scope, $rootScope, FormService, RestService, remoteDeliveryQualities, formData) {

    $scope.remoteDeliveryQualities = remoteDeliveryQualities;
    $scope.formData = formData;
    $scope.connectivityCheckResultShown = false;
    $scope.portConnectivitySuccessful = 'unknown';
    $scope.securePortConnectivitySuccessful = 'unknown';

	$scope.submit = function (form) {
        $scope.connectivityCheckResultShown = false;
        FormService.submitForm('remote-access', $scope.formData, form, $scope);
    };

    $scope.checkConnectivity = function() {
        $scope.connectivityCheckResultShown = false;
        $scope.checkConnectivityInProgress = true;
        $scope.checkSecureConnectivityInProgress = true;

        RestService.invokeAction('checkPortMapping', null, false, function(response) {
            $scope.checkConnectivityInProgress = false;
            $scope.connectivityCheckResultShown = true;
            var errorCode = response.data.errorCode;
            if(errorCode == 0) {
                $scope.portConnectivitySuccessful = 'success';
            } else if (errorCode == 604) {
                $scope.portConnectivitySuccessful = 'failure';
            } else if (errorCode == 605) {
                $scope.portConnectivitySuccessful = 'unknown';
            }
        }, function(response) {
            $scope.checkConnectivityInProgress = false;
            $scope.portConnectivitySuccessful = 'unknown';
            RestService.processError(response);
        });

        RestService.invokeAction('checkSSLPortMapping', null, false, function(response) {
            $scope.checkSecureConnectivityInProgress = false;
            $scope.connectivityCheckResultShown = true;
            var errorCode = response.data.errorCode;
            if(errorCode == 0) {
                $scope.securePortConnectivitySuccessful = 'success';
            } else if (errorCode == 604) {
                $scope.securePortConnectivitySuccessful = 'failure';
            } else if (errorCode == 605) {
                $scope.securePortConnectivitySuccessful = 'unknown';
            }
        }, function(response) {
            $scope.checkSecureConnectivityInProgress = false;
            $scope.securePortConnectivitySuccessful = 'unknown';
            RestService.processError(response);
        });

    };

    $scope.isPasswordNeeded = function() {
        return $rootScope.applicationData.cdsAnonymousEnabled == false;        
    };

    $scope.checkInProgress = function() {
        return $scope.checkSecureConnectivityInProgress || $scope.checkConnectivityInProgress;
    }

}]);